# coding=utf-8
__author__ = '******'
# 获取oracle数据库的ASM信息
import re
import sys
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common.util import *
from common import constants

CLI = None
LANGUAGE = None
CHECK_FAIL = 0
CHECK_PASS = 1
sql_info = {"sql_info_asm_disk"      :       "select * from v$asm_disk",
			"sql_info_asm_diskgroup"      :       "select * from v$asm_diskgroup",
            "sql_info_asm_diskstring"      :       "select name,value from v$parameter where name = 'asm_diskstring'",
            "sql_info_asm_info"      :       "select group_number,disk_number,mount_status,header_status,state,name,path from v$asm_disk",
            "sql_info_asm_failgroup"      :       "select group_number,disk_number,name,failgroup,path from v$asm_disk order by failgroup",
            "sql_info_asm_disk_timeoutparms"      :       "select a.ksppinm name,b.ksppstvl value,a.ksppdesc describe from x$ksppi a,x$ksppcv b where a.inst_id = userenv('instance') and b.inst_id = userenv('instance') and a.indx = b.indx and a.ksppinm like '\\_asm%' escape '\\' order by name",
            
            }


def switchToSql(CLI):
    sqlEnter = "sqlplus \"/as sysdba\""
    sqlSize = 'set linesize 3000'
    CLI.execSql('su - oracle')
    CLI.execSql(sqlEnter)
    CLI.execSql(sqlSize)

def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("DBConn")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    sql_display = context.get("ret_map")
    iswitchSucc, cmd = switchDBConnToASMInstanceConn(context, CLI)
    if iswitchSucc:
        switchToSql(CLI)
        return check_and_get_result(sql_execute(sql_display, CLI, LANGUAGE))
    else:
        log.error(context, "the item collect failed!")
        cmdErrMsg = ''
        if "en" == LANGUAGE:
            cmdErrMsg = cmd + ":\texecute failed\r\n"
        else:
            cmdErrMsg = cmd + u":\t执行失败\r\n"
        switchToSql(CLI)
        sql_display.put("err_msg", cmdErrMsg)
        return sql_display

# 由当前数据库切换到ASM实例数据库
def switchDBConnToASMInstanceConn(context, CLI):
    
    exitCmd = 'exit'
    whoamiCmd = 'whoami'
    queryCurrentOracleCmd = 'ps -ef |grep asm_pmon'
    
    asmInstance = {}
    #如果是通过JDBC连接，由数据库名称访问数据库，则不需要进行切换
    try:
	    if context.get("isUseJdbc"):
	        log.debug(context, "query the oracle by JDBC connect, need not switch user.")
	        return True, ""
	    else:
	       	log.debug(context, "query the oracle by SSH connect, need switch user.")
    except Exception, e:
        log.error(context, "Exception occurred while switching the oracle to asm instance oracle:%s" % str(e))
        raise Exception, e
       
    #如果通过SSH连接，则要退到root用户
    CLI.execSql(exitCmd)
    name = str(CLI.execSql(whoamiCmd).getSqlResult()).lower()
    if not name.__contains__('root'):
        CLI.execSql(exitCmd)

    systemType, _ = getOSType(context, CLI)
    log.debug(context, "the system type is " + systemType)

    try:
        queryCurrentOracleCmdResult = CLI.execSql(queryCurrentOracleCmd)
        if 'TOOLKIT_SEND_SQL_TIME_OUT' in queryCurrentOracleCmdResult.getSqlResult():
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryCurrentOracleCmd, queryCurrentOracleCmdResult.getSqlResult()))
            log.error(context, "the cmd execute time out!")
            return False, queryCurrentOracleCmd

        queryCurrentOracleCmdResultSplit = queryCurrentOracleCmdResult.getSqlResult().splitlines()
        if len(queryCurrentOracleCmdResultSplit) >= 2:
            for line in queryCurrentOracleCmdResultSplit[1:]: 
                if not line.strip().startswith("root"):
                    lineParams = re.split("[ ]+", line.strip())
                    asmInstance["oracleName"] = lineParams[0]
                    asmInstance["oraclePid"] = lineParams[1]
                    asmInstance["oracleSID"] = lineParams[-1].split("_")[-1]
                    break
               
        if not asmInstance:
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryCurrentOracleCmd, queryCurrentOracleCmdResult.getSqlResult()))
            return False, queryCurrentOracleCmd

        queryUserDirectoryCmd = ""
        if constants.OS_TYPE_LINUX_LOW == systemType:
            queryUserDirectoryCmd = "ls -l /proc/%s/fd" % asmInstance.get("oraclePid")
        elif constants.OS_TYPE_AIX_LOW == systemType:
            queryUserDirectoryCmd = "/usr/bin/procfiles -n %s" % asmInstance.get("oraclePid")
        else:
            return False, queryUserDirectoryCmd

        queryUserDirectoryCmdResult = CLI.execSql(queryUserDirectoryCmd)
        if 'TOOLKIT_SEND_SQL_TIME_OUT' in queryUserDirectoryCmdResult.getSqlResult():
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryUserDirectoryCmd, queryUserDirectoryCmdResult.getSqlResult()))
            log.error(context, "the cmd execute time out!")
            return False, queryUserDirectoryCmd
           
        queryUserDirectoryCmdResultSplit = queryUserDirectoryCmdResult.getSqlResult().splitlines()
        for line in queryUserDirectoryCmdResultSplit:
            if asmInstance.get("oracleSID") in line and "/dbs" in line:
                if constants.OS_TYPE_LINUX_LOW == systemType:
                    asmInstance["oracleHome"] = line.split()[-1].split("/dbs")[0]
                    break
                elif constants.OS_TYPE_AIX_LOW == systemType:
                    asmInstance["oracleHome"] = line.split(":/")[-1].split("/dbs")[0]
                    break
                else:
                    continue

        if not asmInstance.get("oracleHome"):
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryUserDirectoryCmd, queryUserDirectoryCmdResult.getSqlResult()))
            return False, queryUserDirectoryCmd

        switchOracleNameCmd = "su - %s" % asmInstance.get("oracleName")
        envOracleHOMECmd = "export ORACLE_HOME=%s" % asmInstance.get("oracleHome")
        envOracleSIDCmd = "export ORACLE_SID=%s" % asmInstance.get("oracleSID")
        switchOracleCmd = "sqlplus / as sysasm"
        queryASMInstanceCmd = "select instance_name from V$instance"
        
        CLI.execSql(switchOracleNameCmd)
        CLI.execSql(envOracleHOMECmd)
        CLI.execSql(envOracleSIDCmd)
        CLI.execSql(switchOracleCmd)
        
        queryASMInstanceCmdResult = CLI.execSql(queryASMInstanceCmd)
        if 'TOOLKIT_SEND_SQL_TIME_OUT' in queryASMInstanceCmdResult.getSqlResult():
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryASMInstanceCmd, queryASMInstanceCmdResult.getSqlResult())) 
            log.error(context, "the cmd execute time out!")
            return False, queryASMInstanceCmd
        
        if not asmInstance.get("oracleSID") in queryASMInstanceCmdResult.getSqlResult():
            log.error(context, "the cmd:%s execute failed, the result is:%s" % (queryASMInstanceCmd, queryASMInstanceCmdResult.getSqlResult()))
            return False, queryASMInstanceCmd
        
    except Exception, e:
        log.error(context, "Exception occurred while switching the oracle to asm instance oracle:%s" % str(e))
        raise Exception, e
    
    return True, ""
       
# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def sql_execute(sql_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for item in sql_info:
        sql_display_temp = CLI.execSql(sql_info.get(item))
        sql_display.put("sql_display" + (item)[8:], sql_display_temp)
        if None == sql_display_temp.getSqlResult() or '' == sql_display_temp.getSqlResult() or 'TOOLKIT_SEND_SQL_TIME_OUT' == sql_display_temp.getSqlResult() or 'TOOLKIT_EXE_CMD_FAILED' == sql_display_temp.getSqlResult():
            if "en" == LANGUAGE:
                fun_err_msg += sql_info.get(item) + ":\texecute failed\r\n"
            else:
                fun_err_msg += sql_info.get(item) + u":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += sql_info.get(item) + ":\texecute success\r\n"
            else:
                fun_err_msg += sql_info.get(item) + u":\t执行成功\r\n"
    sql_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, sql_display, fun_err_msg
   
def getOSType(context, CLI):
    """
    @summary: 查询当前系统的类型
    @param context: 上下文参数
    @return: 命令查询返回结果
    """

    """先判断是否是windows"""
    cliRet = CLI.execSql("echo %OS%").getSqlResult()
    if constants.OS_TYPE_WINDOWS_LOW in cliRet.lower():
        return constants.OS_TYPE_WINDOWS_LOW, cliRet

    """再判断其他系统"""
    cliRet = CLI.execSql("uname -a").getSqlResult()
    if constants.OS_TYPE_VMWARE_LOW in cliRet.lower():
        return constants.OS_TYPE_VMWARE_LOW, cliRet

    if constants.OS_TYPE_SOLARIS_LOW in cliRet.lower() or constants.OS_TYPE_SUNOS_LOW in cliRet.lower():
        return constants.OS_TYPE_SOLARIS_LOW, cliRet

    if constants.OS_TYPE_LINUX_LOW in cliRet.lower():
        return constants.OS_TYPE_LINUX_LOW, cliRet

    if constants.OS_TYPE_AIX_LOW in cliRet.lower():
        return constants.OS_TYPE_AIX_LOW, cliRet

    return "NA" , cliRet
