# coding=utf-8
__author__ = '******'
# 获取linux主机的逻辑卷信息
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_logic_volum_lvmadm_1_0"       ,
               "cmd_info_logic_volum_lvmadm_2_0"       ,
               "cmd_info_logic_volum_lvmadm_2_1"       ,
               "cmd_info_logic_volum_lvmadm_2_2"       ,
               "cmd_info_logic_volum_swlist_MirrorDisk",
               "cmd_info_logic_volum_strings_lvmtab"   ,
               "cmd_info_logic_volum_strings_lvmpvg"   ,
               "cmd_info_logic_volum_pvdisplay"        ,
               "cmd_info_logic_volum_vgdisplay"        ,
               "cmd_info_logic_volum_lvdisplay"        ,
               "cmd_info_logic_volum_swlist_vxvm"  ]
            
cmd_info_desc = ["lvmadm -l -V 1.0",
                 "lvmadm -l -V 2.0",
                 "lvmadm -l -V 2.1",
                 "lvmadm -l -V 2.2",
                 "swlist|grep MirrorDisk",
                 "strings /etc/lvmtab",
                 "strings /etc/lvmpvg",
                 "pvdisplay -v ",
                 "vgdisplay -v",
                 "lvdisplay -vk ",
                 "swlist -l product | grep vxvm"]
            
cmd_info_lv_list = "vgdisplay -v|grep 'LV Name'|awk '{print $3}'"
cmd_info_pv_list = "vgdisplay -v|grep 'PV Name'|awk '{print $3}'"

def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    lv_list = (CLI.execCmdNoLog(cmd_info_lv_list)).splitlines()
    pv_list = (CLI.execCmdNoLog(cmd_info_pv_list)).splitlines()
    for rg in range(len(cmd_info_id)):
        if cmd_info_id[rg]=="cmd_info_logic_volum_lvdisplay":
            for line in lv_list[1:]:
            	if line.find('vgdisplay') == 0:
            		continue
                cmd_display_temp=CLI.execCmdNoLogTimout(cmd_info_desc[rg] + line, 60)
                cmd_display.put("cmd_display" +(cmd_info_id[rg])[8:] + "_vk_" + line, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + line + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + line + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + line + ":\texecute success\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + line + u":\t执行成功\r\n"
        elif cmd_info_id[rg]=="cmd_info_logic_volum_pvdisplay":
            for line in pv_list[1:]:
            	if line.find('vgdisplay') == 0:
            		continue
                cmd_display_temp=CLI.execCmdNoLogTimout(cmd_info_desc[rg] + line, 60)
                cmd_display.put("cmd_display" +(cmd_info_id[rg])[8:] + "_v_" + line, cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + line + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + line + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + line + ":\texecute success\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + line + u":\t执行成功\r\n"
        else:
            cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg], 60)
            cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg