# coding=utf-8
__author__ = '******'
# 获取linux主机的多路径信息
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_multipath_device_mapper"  ,
               "cmd_info_multipath_multipath"      ,
               "cmd_info_multipath_powermt_version",
               "cmd_info_multipath_powermt_display",
               "cmd_info_multipath_config"]
            
cmd_info_desc = ["rpm -qa |grep device-mapper",
                 "multipath -ll",
                 "powermt version",
                 "powermt display dev=all",
                 "cat /etc/multipath.conf"]
				 
cmd_multipath_Huawei_id = ['cmd_info_multipath_version_huawei', 'cmd_info_multipath_path_huawei']
cmd_multipath_Huawei_desc = ['upadmin show version', 'upadmin show vlun']
cmd_multipath_Huawei = zip(cmd_multipath_Huawei_id, cmd_multipath_Huawei_desc)

cmd_multipath_Huawei_old_id = ['cmd_info_multipath_version_huawei_old', 'cmd_info_multipath_path_huawei_old']
cmd_multipath_Huawei_old_desc = ['upadm show version', 'upadm show vlun']
cmd_multipath_Huawei_old = zip(cmd_multipath_Huawei_old_id, cmd_multipath_Huawei_old_desc)

cmd_multipath_EMC_id = ['cmd_info_multipath_version_emc', 'cmd_info_multipath_path_emc']
cmd_multipath_EMC_desc = ['powermt version', 'powermt display dev=all']
cmd_multipath_EMC = zip(cmd_multipath_EMC_id, cmd_multipath_EMC_desc)

cmd_multipath_IBM_id = ['cmd_info_multipath_version_ibm', 'cmd_info_multipath_path_ibm']
cmd_multipath_IBM_desc = ['lslpp -L |grep -i sddpcm', 'pcmpath query device']
cmd_multipath_IBM = zip(cmd_multipath_IBM_id, cmd_multipath_IBM_desc)

cmd_multipath_HDS_id = ['cmd_info_multipath_sys_hds', 'cmd_info_multipath_lu_hds', 'cmd_info_multipath_path_hds']
cmd_multipath_HDS_desc = ['dlnkmgr view -sys', 'dlnkmgr view  -lu', 'dlnkmgr view -path']
cmd_multipath_HDS = zip(cmd_multipath_HDS_id, cmd_multipath_HDS_desc)

cmd_multipath_IBMSDDDSM_id=['cmd_info_multipath_ibmsdddatapath']
cmd_multipath_IBMSDDDSM_desc=['rpm -qa|grep -i IBMsdd or /opt/IBMsdd/bin/datapath query version']
cmd_multipath_IBMSDDDSM=zip(cmd_multipath_IBMSDDDSM_id,cmd_multipath_IBMSDDDSM_desc)


cmd_multipath = [cmd_multipath_Huawei,
                 cmd_multipath_Huawei_old,
                 cmd_multipath_EMC,
                 cmd_multipath_IBM,
                 cmd_multipath_HDS,
                 cmd_multipath_IBMSDDDSM
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    (cmd_storage_info_id, cmd_storage_info_desc) = confirmCmd()
    check_and_get_result(cmd_storage_execute(cmd_display, CLI, LANGUAGE, cmd_storage_info_id, cmd_storage_info_desc))
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))
	
#确认执行命令
def confirmCmd():
    cmdPos = []
    succCmd_id = []
    succCmd_desc = []
    index = -1
    for cmd in cmd_multipath :
        index = index + 1
        for cmd_id, cmd_desc in cmd:
            succ = execTrail(cmd_desc)
            if succ:
                if not index in cmdPos:
                    cmdPos.append(index)
    if len(cmdPos) == 0:
        cmdPos.append(-1)
    for pos in cmdPos:
        if pos == -1:
            for cmd in cmd_multipath :
                for cmd_id, cmd_desc in cmd:
                    succCmd_id.append(cmd_id)
                    succCmd_desc.append(cmd_desc) 
        else:
            cmd = cmd_multipath[pos]
            for cmd_id, cmd_desc in cmd:
                succCmd_id.append(cmd_id)
                succCmd_desc.append(cmd_desc)
    return succCmd_id, succCmd_desc

#尝试执行命令
def execTrail(cmd):
    cmd_display_temp = CLI.execCmdNoLog(cmd)
    if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
        return False
    else:
        return True


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result
    
# 取一个有效值
def check_storage_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result
	
def cmd_storage_execute(cmd_display, CLI, LANGUAGE, cmd_info_id, cmd_info_desc):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg], 60)
        cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg);
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg],60)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg  + cmd_display.get("err_msg"))
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg