# coding=utf-8
__author__ = '******'
# 数据迁移: 获取linux主机:集群基本信息 
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = [
               #RHCS集群版本、配置、状态
               "cmd_info_migrate_rhcs_clster_tat",     
               "cmd_info_migrate_rhcs_clster_toolsta",    
               "cmd_info_migrate_rhcs_clster_node",    
               "cmd_info_migrate_rhcs_clster_disk",    
               "cmd_info_migrate_rhcs_clster_conf",  
               
               #PaceMaker集群版本、配置、状态
               "cmd_info_migrate_pacemaker_cluster_status",  
               "cmd_info_migrate_pacemaker_clster_class",  
               "cmd_info_migrate_pacemaker_clster_mon",  
               
               "cmd_info_migrate_servermodel",#主机类型
               "cmd_info_migrate_cpu",#cpu
               "cmd_info_migrate_memory",#memory
               "cmd_info_migrate_os", 
               
               "cmd_info_migrate_release", 

               "cmd_info_migrate_multipath",#multipath
               "cmd_info_migrate_clustername",
               "cmd_info_migrate_lvmorvxvm"
               
            ]
            
cmd_info_desc = [
                 #RHCS集群
                 "clustat -l",    # 集群状态
                 "cman_tool status", # 集群版本、状态等
                 "cman_tool nodes -a",# 集群节点
                 "mkqdisk -L", # 仲裁盘信息
                 "cat /etc/cluster/cluster.conf ", #集群配置文件
                 
                 #PaceMaker集群
                 "clustat", #集群状态
                 "crm ra classes", #集群资源信息
                 "crm_mon -i 1", #监控集群状态信息
                 
                 "uname -a",
                 "cat /proc/cpuinfo",
                 "cat /proc/meminfo",
                 "cat /etc/*-release",
                 
                 "cat /etc/issue",
                 
                 "multipath -ll",
                 "cman_tool status",
                 "lvm version"
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg],60)
        cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en"==LANGUAGE:
                fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg