# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
from mimify import File
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global LENGTH
global key_lst  #对应Excel中属性列表

#对应excel中的属性字段
key_lst = ["file_system","mounted_point","total_capacity","capacity_used"]

#数据迁移 ：#获取Linux主机集群，文件系统信息
def execute(context):
    
    attribute_arr = []
    
    attrcom_dic = get_attrcom_dic(context)
    
    #求json name
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    
    #求attribute_arr
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    tempList = attr_valuelst_dic[attribute_arr[0]]
    tempListBlock = get_block_lst(tempList)
    #取成功的那个命令的回文
    for lst in tempListBlock:
        if is_success(lst):
            tempList = lst
            break
    fileObjList = []
    try:
        fileObjList = get_file_info(tempList)
    except:
        pass
    value_lst = []
    for fileObj in fileObjList:
        value_lst.append(fileObj.get_name())
        value_lst.append(fileObj.get_mount())
        value_lst.append(fileObj.get_capacity())
        value_lst.append(fileObj.get_used())
        
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,"result",result)
    return context


def get_value_lst(length,values_temp):
    v_lst = []
    row_num = len (values_temp)/length
    # 行数：1 - 6
    for i in range(1,row_num):
        v_lst.append(values_temp[length*i])
        v_lst.append(values_temp[length*i+6])
        v_lst.append(values_temp[length*i+2])
        v_lst.append(values_temp[length*i+5])
    return v_lst


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

def get_file_info(tempList):
    fileObjList = []
    
    if(not is_belong_lst('Mount',tempList) and not is_belong_lst('Point',tempList) and not is_belong_lst('------',tempList)):
        fileObj = File_Entity()
        fileObjList.append(fileObj)
        return fileObjList
            
    
    if len(tempList):
        failStr = 'TOOLKIT_EXE_CMD_FAILED'
        for line in tempList:
            if failStr.lower() in line.lower():
                fileObj = File_Entity()
                fileObjList.append(fileObj)
                return fileObjList
        
        for i in range(len(tempList)):
            if '---' in tempList[i].lower():
                tempList = tempList[i+1:-1]
                break
        #过滤不合法的数据
        tempListSec = []
        for line in tempList:
            if ('unknown' not in line.lower()) and ('version' not in line.lower()):
                tempListSec.append(line)
        
        for line in tempListSec:
            fileObj = File_Entity()
            tempArr = re.split('\\s+', line)
            nameList = tempArr[1:-5]
            capacity = ""
            free = ""
            used = ""
            if len(nameList) > 1:
                devicename = ''
                for name in nameList:
                    devicename = devicename + name + ' '
                fileObj.set_name(devicename.strip())
            elif len(nameList) == 1:
                fileObj.set_name(nameList[0])
            fileObj.set_mount(tempArr[0])
            try:
                capacity = tempArr[-2]
                fileObj.set_capacity(str(round(float(capacity)/1024.0/1024.0/1024.0,2))+'GB')
                free = tempArr[-1]
                used = float(capacity) - float(free)
            except:
                pass
            usedPen = 0
            try:
                if (capacity != '0'):
                    usedPen = round(used/float(capacity),4)*100
                else:
                    usedPen = 0
            except:
                pass
            fileObj.set_used(str(usedPen)+'%')
            fileObjList.append(fileObj)
        return fileObjList
    else:
            fileObj = File_Entity()
            fileObjList.append(fileObj)
            return fileObjList
        

#功能说明：返回单个命令回文列表组成的列表
def get_block_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList

class File_Entity:
    __file_name = 'NA'
    __file_mount = 'NA'
    __file_capacity  = 'NA'
    __file_used = 'NA'
    
    def get_name(self):
        return self.__file_name
    def get_mount(self):
        return self.__file_mount
    def get_capacity(self):
        return self.__file_capacity
    def get_used(self):
        return self.__file_used
    
    def set_name(self,name):
        self.__file_name = name
    def set_mount(self,mount):
        self.__file_mount = mount
    def set_capacity(self,capacity):
        self.__file_capacity = capacity
    def set_used(self,used):
        self.__file_used = used

