# --*-- coding:utf-8 --*--
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import re
import sys 
reload(sys) 
sys.setdefaultencoding('utf-8')

CLI = None
LANGUAGE = None
CHECK_FAIL = 0
CHECK_PASS = 1
cmd_info_id = [
               "cmd_info_storage_group_sg" 
               ]
            
cmd_info_desc = [ 
                 "naviseccli -Scope 0 getall -sg" 
                ]
#naviseccli –Scope 0 getlun 10 –uid -capacity -name -state


cmd_info_storage_groupname = "naviseccli -Scope 0 getall -sg"


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    global cmd_info_id
    global cmd_info_desc
    
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    #new 
    #获取每个storage所对应的列表
    storage_value_lst = get_cmdlst_storagegroup(CLI,cmd_info_storage_groupname)
    #获取每个storage对象所组成的列表
    storage_bean_lst = get_storagebean_lst(storage_value_lst)
    #根据storage_bean_lst求cmd_desc
    set_cmd_desc(storage_bean_lst)
    
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))

#根据storage_bean_lst求cmd_desc
def set_cmd_desc(storage_beanlst):
    for bean in storage_beanlst:
        if len(bean.get_alunum_lst())>0:
            for num in bean.get_alunum_lst():
                #naviseccli –Scope 0 getlun 10 –uid -capacity -name -state
                cmd_desc = "naviseccli -Scope 0 getlun"+" "+num+" "+"-uid"+" -capacity -name -state -isthinlun -ismetalun"
                cmd_info_desc.append(cmd_desc)
                cmd_id = "cmd_info_storage_"
                cmd_id = cmd_id + bean.get_groupname()+"_alu"+num
                cmd_info_id.append(cmd_id)
                

#获取每个storage对象所组成的列表
def get_storagebean_lst(storage_lst):
    storage_bean_lst = []
    for lst in storage_lst:
        storage_bean = Storage_Group()
        storage_bean = get_storagebean_bylst(lst)
        storage_bean_lst.append(storage_bean)
    return storage_bean_lst


#根据一个storage group的回文生成一个 storage对象
def get_storagebean_bylst(storage_lst):
    storage_bean = Storage_Group()
    if (None == storage_lst) or (0 == len(storage_lst)):
        return storage_bean
    for line in storage_lst:
        if ('storage' in line.lower()) and ('group' in line.lower()) and ('name' in line.lower()):
            name = line.split(':')[-1].strip()
            storage_bean.set_groupname(name)
            break
    #求alu num lst
    start = 0
    end = 0
    has_alu = False
    for i,line in enumerate(storage_lst):
        if ('alu' in line.lower()) and ('number' in line.lower()):
            start = i + 2
            has_alu = True
            continue
        elif 'shareable' in line.lower():
            end = i 
            break
    if has_alu:
        alu_lst = storage_lst[start:end]
        alu_num_lst = []
        for alu in alu_lst:
            alu = alu.strip()
            line_lst = re.split('\\s+',alu)
            num = line_lst[-1].strip()
            alu_num_lst.append(num)
        storage_bean.set_alunum_lst(alu_num_lst)
    else:
        pass
    return storage_bean
 

#获取每个storage所对应的列表
def get_cmdlst_storagegroup(CLI,cmd_desc):
    cmd_value_temp = CLI.execCmd(cmd_desc)
    cmd_value_lst = cmd_value_temp.splitlines()
    #过滤掉无用的数据
    check_lst = []
    for line in cmd_value_lst:
        if '' != line.strip():
            check_lst.append(line)
    cmd_value_lst = check_lst
    #每个storage group对应一个lst
    storagelst_lst = []
    storage_index_lst = []
    for i,line in enumerate(cmd_value_lst):
        if ('storage' in line.lower()) and ('group' in line.lower()) and ('name' in line.lower()):
            storage_index_lst.append(i)
    
    len_indexlst = len(storage_index_lst)
    for j in range(len_indexlst):
        lst = []
        start = storage_index_lst[j]
        try:
            end = storage_index_lst[j+1]
        except:
            end = len(cmd_value_lst)
            
        lst = cmd_value_lst[start:end]
        storagelst_lst.append(lst)
    return storagelst_lst 

# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result

class Storage_Group:
    __group_name = 'NA'
    __ALU_Num_lst = []
    def get_groupname(self):
        return self.__group_name
    def get_alunum_lst(self):
        return self.__ALU_Num_lst
    def set_groupname(self,name):
        self.__group_name = name
    def set_alunum_lst(self,lst):
        self.__ALU_Num_lst = lst
    

def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmd(cmd_info_desc[rg])
        cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg

